// TreeCtrlDlg.cpp : implementation file
//

#include "stdafx.h"
#include "TreeCtrl.h"
#include "TreeCtrlDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTreeCtrlDlg dialog

CTreeCtrlDlg::CTreeCtrlDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTreeCtrlDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTreeCtrlDlg)
	m_l = _T("");
	m_a = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTreeCtrlDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTreeCtrlDlg)
	DDX_Control(pDX, IDC_TREE, m_hTree);
	DDX_Text(pDX, IDC_EDIT, m_l);
	DDX_Text(pDX, IDC_EDIT_1, m_a);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CTreeCtrlDlg, CDialog)
	//{{AFX_MSG_MAP(CTreeCtrlDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_NOTIFY(NM_CLICK, IDC_TREE, OnClickTree)
	ON_NOTIFY(NM_DBLCLK, IDC_TREE, OnDblclkTree)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTreeCtrlDlg message handlers

BOOL CTreeCtrlDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
    CTreeCtrl* pTree = (CTreeCtrl*) GetDlgItem(IDC_TREE);
  
	//       
    pTree->SetTextColor(RGB(0, 0, 255));
    pTree->SetBkColor(RGB(255,255,128));
    pTree->Invalidate();
    
	//   
	TV_INSERTSTRUCT tvin;
    tvin.hParent = NULL;
    tvin.hInsertAfter = TVI_LAST;
    tvin.item.mask =  TVIF_TEXT | TVIF_PARAM;
    tvin.item.hItem = NULL;
    tvin.item.state = 0;
    tvin.item. stateMask = 0;
    tvin.item.cChildren = 0;
    
    //  
    tvin.item.pszText = "";
	tvin.item.lParam = 5;
    HTREEITEM hFirst = pTree->InsertItem(&tvin);
	tvin.item.pszText = "";
    tvin.item.lParam = 6;
    HTREEITEM hSecond = pTree->InsertItem(&tvin);
    //  
    tvin.hParent = hFirst;
    tvin.item.pszText = "A"; 
	tvin.item.lParam = 0;
    pTree->InsertItem(&tvin);

    tvin.item.pszText = "B";
	tvin.item.lParam = 1;
    pTree->InsertItem(&tvin);
    //  
    tvin.hParent = hSecond;
    tvin.item.pszText = "A";
	tvin.item.lParam = 2;
    pTree->InsertItem(&tvin);
    tvin.item.pszText = "B";
	tvin.item.lParam = 3;
    pTree->InsertItem(&tvin);
    tvin.item.pszText = "C";
	tvin.item.lParam = 4;
    HTREEITEM hOther = pTree->InsertItem(&tvin);
 
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CTreeCtrlDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTreeCtrlDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;

		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTreeCtrlDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


void CTreeCtrlDlg::OnClickTree(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
   CPoint point;
   GetCursorPos(&point);
   m_hTree.ScreenToClient(&point);
   UINT uFlags;
   HTREEITEM hItem = m_hTree.HitTest(point, &uFlags);
   
   if ((hItem != NULL) && (TVHT_ONITEM & uFlags)) // && -  , & -  ,    
	   {        m_hTree.Select(hItem, TVGN_CARET);
                m_hTree.ClientToScreen(&point);
                DWORD ItemData=m_hTree.GetItemData(hItem);
        

	    if (ItemData==0) 
        m_l="A";

        UpdateData(FALSE);
		
	    if (ItemData==1)
        m_l="B";

		UpdateData(FALSE);

		if (ItemData==2) 
        m_l="A";

		UpdateData(FALSE);

		if (ItemData==3) 
        m_l="B";

		UpdateData(FALSE);

		if (ItemData==4) 
        m_l="C";
       
		UpdateData(FALSE);

		if (ItemData==5) 
			m_a="  ";

		UpdateData(FALSE);

        if (ItemData==6) 
            m_a="  ";

		UpdateData(FALSE);

		}
	*pResult = 0;
}

void CTreeCtrlDlg::OnDblclkTree(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
   CPoint point;
   GetCursorPos(&point);
   m_hTree.ScreenToClient(&point);
   UINT uFlags;
   HTREEITEM hItem = m_hTree.HitTest(point, &uFlags);
   
   if ((hItem != NULL) && (TVHT_ONITEM & uFlags)) // && -  , & -  ,    
	   {        m_hTree.Select(hItem, TVGN_CARET);
                m_hTree.ClientToScreen(&point);
                DWORD ItemData=m_hTree.GetItemData(hItem);
   if (ItemData==5)
                *pResult = 0;
   else
   if (ItemData==6)
	            *pResult = 0;
   else
				AfxMessageBox(" Dblclk Button Click ");
   }
	*pResult = 0;
}








